
files = ["adjust-map.par","align-mask-start.par","align-mask-start-middle.par",\
         "badorders.par","biasflat.par","extract-2dspec.par",\
         "ldss3-pattern.par","map-spectra.par","Sflats.par","stitch.par",\
         "subsky-galaxy.par","subsky-star.par","sumspec.par","viewspectra.par"]

adjustmap="""SEARCH_HEIGHT,i,h,4,,,"half height of search range"
SEARCH_WIDTH,i,h,2,,,"half-width of search range"
SLIT_WIDTH,i,h,6,,,"slit width"
ORD_DISP,i,h,3,,,"order of dispersion error fit"
ORD_SAG,i,h,2,,,"order of spectrum y position error fit"
MINLINES,i,h,5,,,"minimum # of lines for tweak"
LINELIST,f,h,"HeNeAr.dat",,,"line list file"
EDGE,i,h,2,,,"slit edge to exclude"
SIGLIMIT,r,h,3.000000,,,"line rejection threshold"
ITERATIONS,i,h,5,,,"number of iterations"
OUTLIER-WT,b,h,y,,,"underweight outlying point?"
NCLUMP,i,h,6,,,"number of points in clumps for underweighting"
HISTOGRAM,b,h,y,,,"use histogram to reject lines outside search region?"
mode,s,h,"q1",,,"""

alignmaskstartmiddle="""SEARCHBOX,i,h,7,,,"half width of search range"
MAGFACTOR,i,h,100,,,"magnification factor for offset vectors"
LAMFILE,s,h,"middle.dat",,,"line list file"
NAVER,i,h,1,,,"number of neighboring points to average"
THRESHOLD,r,h,0.300000,,,"minimum flux ratio spot to background"
mode,s,h,"q1",,,"""

alignmaskstart="""SEARCHBOX,i,h,30,,,"half width of search range"
MAGFACTOR,i,h,100,,,"magnification factor for offset vectors"
LAMFILE,s,h,"afea.dat",,,"line list file"
NAVER,i,h,1,,,"number of neighboring points to average"
THRESHOLD,r,h,0.300000,,,"minimum flux ratio spot to background"
mode,s,h,"q1",,,"""

badorders="""border,i,h,0,,,"width of border around spectral regions"
linefile,s,h,"sky_lines_list",,,"2nd order line list"
orders,s,h,"02",,,"orders to mask"
hwidth,r,h,3.000000,,,"half-width of 2nd order lines"
shuffle,i,h,0,,,"shuffle distance"
lambda0,r,h,0.000000,,,"min lambda of zero order spectrum"
lambda1,r,h,0.000000,,,"max lambda of zero order spectrum"
mode,s,h,"q1",,,"""

biasflat="""dewar,s,h,"SITE",,,"dewar definition file"
flat_file,s,h,"none",,,"flat field frame"
bias_file,s,h,"none",,,"bias frame"
gain1,r,h,0.820000,,,"chip1 gain"
gain2,r,h,0.850000,,,"chip2 gain"
gain3,r,h,0.870000,,,"chip3 gain"
gain4,r,h,1.130000,,,"chip4 gain"
gain5,r,h,0.770000,,,"chip5 gain"
gain6,r,h,0.930000,,,"chip6 gain"
gain7,r,h,0.920000,,,"chip7 gain"
gain8,r,h,0.800000,,,"chip8 gain"
mode,s,h,"q1",,,"""

extract2dspec="""deltalam,r,h,2.000000,,,"wavelength step"
deltaslit,r,h,0.200000,,,"slit postion interval in arcseconds"
telscale,r,h,2.899000,,,"telescope scale sec per mm"
search,i,h,0,,,"half width of search region"
trace,s,h,"none",,,"spectrum trace method"
trace_order,i,h,3,,,"order of fit to spectrum trace"
align,s,h,"none",,,"alignment method"
obj_frac,r,h,0.300000,,,"fraction of galaxies used for alignment"
init_off,r,h,0.000000,,,"initial object offset guess, in pixels"
minlambda,r,h,0.000000,,,"min wavelength of extraction"
maxlambda,r,h,0.000000,,,"max wavelength of extraction"
sub_ns,b,h,n,,,"subtract shuffled region of n&s data?"
sampling,s,h,"linear",,,"linear or log sampling"
edge,i,h,0,,,"excluded edge of spectrum"
use_holes,b,h,y,,,"extract alignment stars?"
mode,s,h,"q1",,,"""

ldss3pattern="""dewar,s,h,"LDSS3-2",,,"dewar name"
top,i,h,100,,,"noise reference size in pixels"
intermediate,b,h,n,,,"output intermediate fits files"
iterations,i,h,3,,,"number of passes"
scale1,r,h,500,,,"smoothing pass 1"
scale2,r,h,300,,,"smoothing pass 2"
scale3,r,h,300,,,"smoothing pass 3"
cut1,r,h,5.0,,,"clipping pass 1"
cut2,r,h,3.0,,,"clipping pass 2"
cut3,r,h,2.5,,,"clipping pass 3"
mode,s,h,"q1",,,"""

mapspectra="""minlambda,r,h,3500.000000,,,"minimum wavelength"
minpixl,i,h,100,,,"minimum # pixels/spectrum"
maxlambda,r,h,10000.000000,,,"maximum wavelength"
use_holes,b,h,y,,,"map holes as well as slits?"
mode,s,h,"q1",,,"""

sflats="""minlambda,r,h,0.000000,,,"min wavelength of extraction"
maxlambda,r,h,0.000000,,,"max wavelength of extraction"
telscale,r,h,2.899000,,,"telescope scale sec per mm"
bias_file,s,h,"none",,,"bias level file"
siglimit,r,h,4.000000,,,"CR rejection threshold in sigmas"
noise,r,h,3.000000,,,"CCD read noise"
gain,r,h,1.300000,,,"CCD gain"
order,i,h,5,,,"order of flat intensity fit"
fit_mode,s,h,"median",,,"method of spectrum fitting"
med_box,i,h,100,,,"size of sky fit median box"
shuffled,i,h,0,,,"number of pixels to shuffle data"
mode,s,h,"q1",,,"""

stitch="""bias_file,s,h,"none",,,"bias frame"
gain1,r,h,0.720000,,,"chip1 gain"
gain2,r,h,0.760000,,,"chip2 gain"
gain3,r,h,0.720000,,,"chip3 gain"
gain4,r,h,0.760000,,,"chip4 gain"
dewar,s,h,"LDSS3-4",,,"dewar name"
mode,s,h,"q1",,,"""

subskygalaxy="""minlambda,r,h,0.000000,,,"min wavelength of extraction"
maxlambda,r,h,0.000000,,,"max wavelength of extraction"
exclude,i,h,3,,,"half width of exclusion region"
deltaknot,r,h,1.000000,,,"dispersion knot interval, in pixels"
splineorder,i,h,3,,,"order of dispersion spline fit to sky"
2d_spline,b,h,y,,,"Perform 2-d spline fit to spectra?"
spaceorder,i,h,1,,,"order of spatial spline fit to sky"
medbox,i,h,15,,,"boxsize for running median CR rejection"
siglimit,r,h,10.000000,,,"CR rejection threshold in sigmas"
diag_0,r,h,5520.000000,,,"lower limit of diagnostic range"
diag_1,r,h,5620.000000,,,"upper limit of diagnostic range"
edge,i,h,1,,,"excluded edge of spectrum"
noise,r,h,3.000000,,,"CCD read noise"
gain,r,h,1.300000,,,"CCD gain"
mode,s,h,"q1",,,"""

subskystar="""minlambda,r,h,0.000000,,,"min wavelength of extraction"
maxlambda,r,h,0.000000,,,"max wavelength of extraction"
exclude,i,h,2,,,"half width of exclusion region"
deltaknot,r,h,1.000000,,,"dispersion knot interval, in pixels"
splineorder,i,h,3,,,"order of dispersion spline fit to sky"
2d_spline,b,h,y,,,"Perform 2-d spline fit to spectra?"
spaceorder,i,h,1,,,"order of spatial spline fit to sky"
medbox,i,h,5,,,"boxsize for running median CR rejection"
siglimit,r,h,8.000000,,,"CR rejection threshold in sigmas"
diag_0,r,h,5520.000000,,,"lower limit of diagnostic range"
diag_1,r,h,5620.000000,,,"upper limit of diagnostic range"
edge,i,h,1,,,"excluded edge of spectrum"
noise,r,h,3.000000,,,"CCD read noise"
gain,r,h,1.300000,,,"CCD gain"
mode,s,h,"q1",,,"""

sumspec="""clean,b,h,y,,,"remove cosmic rays"
siglimit,r,h,4.500000,,,"CR rejection threshold in sigmas"
both,b,h,n,,,"remove both positive and negative residuals?"
iterations,i,h,1,,,"number of iterations of cleaning"
grow,i,h,0,,,"grow deleted region size"
mode,s,h,"q1",,,"""

viewspectra="""smooth,i,h,10,,,"size of smoothing box in angstroms"
linelist,s,h,"linelist",,,"galaxy line list"
nod,i,h,0,,,"telescope nod distance, in pixels"
shuffle,b,h,n,,,"shuffled spectra?"
hlfwdth,i,h,2,,,"halfheight of spectrum extraction box"
lamint,r,h,100.000000,,,"halfwidth of line exam window"
lambda0,r,h,0.000000,,,"minimum wavelength to display"
lambda1,r,h,0.000000,,,"maximum wavelength to display"
mode,s,h,"q1",,,"""
