import time,sys,os
from Numeric import *
import socket,random

###############################################################################
#
#def big(stuff):
#    t0 = time.time()
#    ones((1000,1000,100)) # about 10 seconds
#    t1 = time.time()
#    print stuff,t1-t0,'seconds'
#
#
###############################################################################

MaxQueue = 2
WaitTime = 0.1
verb = 0
perf = 0

class ForkAFunc:
    def __init__(self,func):
        self.func = func
    def run(self,iter,verb,perf,args):
        pid = os.fork()
        if pid==0:
            # parent
            sockClient = socket.socket(socket.AF_INET,socket.SOCK_STREAM)
            cpid = os.getpid()
            if verb > 1: print args,"child",cpid
            #apply(self.func,(args,))
            self.func(iter,verb,perf,*args)
            sockClient.connect(('localhost',2727))
            sockClient.send("%i" % (cpid))
            sockClient.close()
            os._exit(0)
    
        else:
            # child
            return pid

def ForkQueue(func,listing,verb=verb,perf=perf,MaxQueue=MaxQueue,WaitTime=WaitTime):
    PROCESS_QUEUE = []
    sockServer = socket.socket(socket.AF_INET,socket.SOCK_STREAM)
    sockServer.bind(('',2727))
    sockServer.listen(1)
    f = ForkAFunc(func)
    obj = 0
    while obj < len(listing) or len(PROCESS_QUEUE) > 0:
        if len(PROCESS_QUEUE) < MaxQueue and obj < len(listing):
            if verb: print "Starting process %i" % (obj); print
            pid = f.run(obj,verb,perf,listing[obj])
            obj += 1
            PROCESS_QUEUE.append(str(pid))
            if verb > 1: print PROCESS_QUEUE
        else:
            if verb: print 'Waiting'; print
            channel,details = sockServer.accept()
            pid = channel.recv(100)
            os.waitpid(int(pid),0)
            PROCESS_QUEUE.remove(pid)
            if verb > 1: print PROCESS_QUEUE
            channel.close()
        time.sleep(WaitTime)

    print 'Finished'



#t00 = time.time()
#ForkQueue(big,arange(6),MaxQueue=2,WaitTime=0.1)
#t11 = time.time()
#print 'Total time',t11-t00
