#!/usr/bin/env python

import os,sys

exec(open("parameters.dat","r").read())

stage1 = 0
stage2 = 0
stage3 = 0

for arg in sys.argv:
    if arg in ("-s1","--stage1"): stage1 = 1
    elif arg in ("-s2","--stage2"): stage2 = 1
    elif arg in ("-s3","--stage3"): stage3 = 1
    elif arg in ("-all","--all-stages"): stage1 = 1; stage2 = 1; stage3 = 1

#print globals()
### Stage1
if stage1:
    if 'minlambda' in globals(): 
        os.system("Cosmospar.py -nb -e minlambda %r" % (minlambda))
    if 'maxlambda' in globals(): 
        os.system("Cosmospar.py -nb -e maxlambda %r" % (maxlambda))
    if 'search_height' in globals(): 
        os.system("Cosmospar.py -nb -e search_height %r" % (search_height))
    if 'search_width' in globals(): 
        os.system("Cosmospar.py -nb -e search_width %r" % (search_width))
    if 'slit_width' in globals(): 
        os.system("Cosmospar.py -nb -e slit_width %r" % (slit_width))
    if 'ord_disp' in globals(): 
        os.system("Cosmospar.py -nb -e ord_disp %r" % (ord_disp))
    if 'ord_sag' in globals(): 
        os.system("Cosmospar.py -nb -e ord_sag %r" % (ord_sag))
### Stage3
if stage2 or stage3:
    if 'exclude1' in globals(): 
        os.system("Cosmospar.py -nb -f subsky-star.par exclude %r" % (exclude1))
    if 'spline2d1' in globals(): 
        os.system("Cosmospar.py -nb -f subsky-star.par 2d_spline %r" % (spline2d1))
    if 'medbox1' in globals(): 
        os.system("Cosmospar.py -nb -f subsky-star.par medbox %r" % (medbox1))
    if 'siglimit1' in globals(): 
        os.system("Cosmospar.py -nb -f subsky-star.par siglimit %r" % (siglimit1))
    if 'edge1' in globals(): 
        os.system("Cosmospar.py -nb -f subsky-star.par edge %r" % (edge1))
    if 'exclude2' in globals(): 
        os.system("Cosmospar.py -nb -f subsky-galaxy.par exclude %r" % (exclude2))
    if 'spline2d2' in globals(): 
        os.system("Cosmospar.py -nb -f subsky-galaxy.par 2d_spline %r" % (spline2d2))
    if 'medbox2' in globals(): 
        os.system("Cosmospar.py -nb -f subsky-galaxy.par medbox %r" % (medbox2))
    if 'siglimit2' in globals(): 
        os.system("Cosmospar.py -nb -f subsky-galaxy.par siglimit %r" % (siglimit2))
    if 'edge2' in globals(): 
        os.system("Cosmospar.py -nb -f subsky-galaxy.par edge %r" % (edge2))
    if 'noise' in globals(): 
        os.system("Cosmospar.py -nb -e noise %r" % (noise))
    if 'gain' in globals(): 
        os.system("Cosmospar.py -nb -e gain %r" % (gain))
if not stage1 and not stage2 and not stage3:
    print "missing parameters"
